Var Y_BGG GDP_BGG I_BGG K_BGG l_BGG U_BGG C_BGG C_e_BGG C_p_BGG C_b_BGG varrho_BGG R_BGG R_gov_BGG Rk_BGG rk_BGG RL_BGG w_BGG a a_I g sigma Q_BGG infl_BGG mc_BGG wm_BGG N_BGG V_BGG phi_e_BGG phi_e_r_BGG ombar_BGG L_BGG L_r_BGG L_e_BGG N_b_BGG Profratio_BGG phi_b_BGG z_BGG Rat_BGG s2_4_BGG s3_4_BGG s4_4_BGG R_4_BGG Rk_4_BGG infl_4_BGG k_BGG N_shadow_BGG L_e_BGG_shadow;
Var eps_p eps_w eps_c;
varexo e_a e_N e_i e_g e_Rb e_a_I e_p e_w e_sigma e_c;

parameters alpha delta beta chi c_U psi_k psi_l varphi hh eta_i xi gamma_P kappa_pi kappa_dpi kappa_X kappa_GDP kappa_Y rho_i rho_g rho_a rho_a_I rho_sigma rho_e_lambda rho_e_p mu_e_p rho_e_w mu_e_w rho_e_c epsilon mu epsilonw xiw gamma_W sigma_ss brate gamma We Theta Thetab_BGG pin theta_ss chi_e chi_sigma;
parameters Y_ss GDP_ss K_ss YK_ss l_ss C_ss C_e_ss C_p_ss C_b_ss I_ss Gov_ss govshare R_ss varrho_ss Rk_ss rk_ss Rb_ss RL_ss s1_ss s2_ss s_cris_ss Pm_ss k_ss w_ss X_ss infl_ss S_ss N_ss V_ss phi_e_ss phi_e_r_ss omegabar_ss tromegabar_ss om_pr_ss F_ss Gamma_ss Gamma_1 Gamma_2 G_ss G_1 G_2 def_ss xi_ss L_ss L_r_ss L_e_ss Expr1 Expr2 Expr3 N_b_ss Nbe_ss Nbn_ss x_ss z_ss phi_b_ss;

load temp1;
load temp_simtype;

//Households
beta    =   p_Full(1);
hh       =  p_Full(2);
varphi  =   p_Full(3);
s_nr    =   p_Full(4);

//Wage Setting;
epsilonw=   p_Full(5);
xiw     =   p_Full(6);
gamma_W =   p_Full(7);

//Entrepreneurs
alpha   =   p_Full(8);
delta   =   p_Full(9);
sigma_ss=   p_Full(10);
pin     =   p_Full(11);
Theta   =   p_Full(12);
gamma   =   p_Full(13);
c_U     =   p_Full(14);
psi_k   =   p_Full(15);
psi_l   =   p_Full(16);
mu      =   p_Full(17);

//bankers
theta_ss =  p_Full(18);
Thetab_BGG  =   0;
Thetab  =   p_Full(19);

//Capital good's producers
eta_i   =   p_Full(20);

//Retailers
xi      =   p_Full(21);
gamma_P =   p_Full(22);
epsilon =   p_Full(23);
S_ss    =   p_Full(24);

//Monetary Policy
kappa_pi=   p_Full(25);
kappa_dpi=  p_Full(26);
kappa_X =   p_Full(27);
kappa_Y =   p_Full(28);
rho_i   =   p_Full(29);
kappa_GDP=  p_Full(30);

//shock process
rho_a   =   p_Full(31);
rho_g   =   p_Full(32);
rho_a_I =   p_Full(33);
rho_e_lambda=p_Full(34);
rho_e_c =   p_Full(35);
sd_a    =   p_Full(36);
sd_i    =   p_Full(37);
sd_g    =   p_Full(38);
sd_I_a_I=   p_Full(39);
sd_e_N  =   p_Full(40);
sd_e_z  =   p_Full(41);
sd_e_lambda=p_Full(42);
sd_e_c  =   p_Full(43);

//calibrated Steady State Values
infl_ss =   p_Full(44);
govshare=   p_Full(45);
s2_ss   =   p_Full(46);
l_ss    =   p_Full(47);            
phi_b_ss=   p_Full(48);          
brate   =   p_Full(49);

//shock processes continued 
sd_e_p  =   p_Full(50);
rho_e_p =   p_Full(51);
mu_e_p  =   p_Full(52);

sd_e_w  =   p_Full(53);
rho_e_w =   p_Full(54);
mu_e_w  =   p_Full(55);

sd_e_sigma  = p_Full(56);
rho_sigma =   p_Full(57);


//Steady State
R_ss    =   1/beta*infl_ss;

//Most variables and backed out parameters pertaining to the entrepreneurial sector
omegabar_ss=   exp(sigma_ss*norminv(brate,0,1)-0.5*sigma_ss^2);
tromegabar_ss= (log(omegabar_ss)+0.5*sigma_ss^2)/sigma_ss;
F_ss    =   normcdf(tromegabar_ss,0,1);
F_1     =   1/(omegabar_ss*sigma_ss)*normpdf(tromegabar_ss,0,1);
F_11    =   -F_1/omegabar_ss*(1+(log(omegabar_ss)+0.5*sigma_ss^2)/sigma_ss^2);
F_12    =   -F_1/sigma_ss*(1+(0.25*sigma_ss^4-(log(omegabar_ss))^2)/sigma_ss^2);
F_2     =   (0.5*sigma_ss^2-log(omegabar_ss))/sigma_ss^2*normpdf(tromegabar_ss,0,1);
G_ss    =   normcdf(tromegabar_ss-sigma_ss);
G_1    =    omegabar_ss*F_1;
G_11    =   F_1+omegabar_ss*F_11;
G_12    =   omegabar_ss*F_12;
G_2     =   ((0.5*sigma_ss^2-log(omegabar_ss))/sigma_ss^2-1)*normpdf(tromegabar_ss-sigma_ss,0,1);
Gamma_ss  =   omegabar_ss*(1-F_ss)+G_ss;
Gamma_1   =   1-F_ss;
Gamma_2   =   -omegabar_ss*F_2+G_2;
Gamma_11  =   -F_1;
Gamma_12  =   -F_2;
Expr1   =   Gamma_ss-mu*G_ss;
Expr2   =   Gamma_1-mu*G_1;
Expr3   =   Gamma_2-mu*G_2;
xi_ss =   Gamma_1/Expr2;
s1_ss   =   Gamma_1/(Gamma_1-mu*(G_1*(1-Gamma_ss)+Gamma_1*G_ss));
phi_e_ss=   1/(1-Expr1*s1_ss);
Rb_ss   =   R_ss; // no s2_ss, return on bank loans equals risk free rate
Rk_ss   =   Rb_ss*s1_ss;
RL_ss   =   omegabar_ss*Rk_ss/(1-1/phi_e_ss);

//most real variables
X_ss    =   epsilon/(epsilon-1);
rk_ss   =   Rk_ss/infl_ss-(1-delta);
Pm_ss   =   1/X_ss; 
Q_ss    =   1;
k_ss    =   (alpha/(X_ss*(1+psi_k*(R_ss-1))*(Rk_ss/infl_ss-1+delta)))^(1/(1-alpha));
w_ss    =   1/(X_ss*(1+psi_l*(R_ss-1)))*(1-alpha)*k_ss^alpha;
YK_ss   =   X_ss/alpha*(Rk_ss/infl_ss-1+delta)*(1+psi_k*(R_ss-1));
K_ss    =   l_ss*k_ss;
Y_ss     =  YK_ss*K_ss;
Gov_ss  =   govshare*Y_ss;
I_ss    =   delta*K_ss;

//Remaining entrepreneurial variables
om_pr_ss=   omegabar_ss*Rk_ss;
V_ss    =   K_ss*Rk_ss/infl_ss*(1-Gamma_ss);
N_ss    =   K_ss/phi_e_ss;
L_e_ss  =   K_ss-N_ss;
L_r_ss  =   psi_k*rk_ss*K_ss+psi_l*w_ss*l_ss;
L_ss    =   L_r_ss+L_e_ss;
We      =   N_ss-gamma*V_ss;

//Banking Sector variables and backed out parameters
z_ss    =   ((Rb_ss-R_ss)*phi_b_ss+R_ss)/infl_ss;
x_ss    =   z_ss;
N_b_ss  =   L_e_ss/phi_b_ss;
Nbe_ss  =   theta_ss*z_ss*N_b_ss;
Nbn_ss  =   N_b_ss-Nbe_ss;

//Consumption, GDP, varrho, chi
C_e_ss  =   (1-gamma)*Theta*V_ss;
C_b_ss  =   Thetab_BGG*(1-theta_ss)*z_ss*N_b_ss;
C_ss    =   Y_ss-I_ss-Gov_ss-C_e_ss-C_b_ss-mu*G_ss*Rk_ss/infl_ss*K_ss;
C_p_ss  =   C_ss+C_e_ss+C_b_ss;
GDP_ss  =   C_p_ss+I_ss+Gov_ss;
varrho_ss=  1/(C_ss*(1-hh));
chi     =   varrho_ss*w_ss/l_ss^varphi*(epsilonw-1)/epsilonw; // backed out parameter: weight of labour in utility function

//Calculation of coefficient on entrepreneurial leverage chi_e and on sigma chi_sigma
Upsilon     =   1-Gamma_ss+xi_ss*Expr1;
domegabards1=-Expr1/(Expr2*s1_ss);
domegabardphi_e=(1-Expr1*s1_ss)/(Expr2*s1_ss*phi_e_ss);
domegabardsigma=-Expr3/Expr2;
xi_1  =   mu*(Gamma_1*G_11-Gamma_11*G_1)/(Expr2^2);
xi_2  =   mu*(Gamma_1*G_12-Gamma_12*G_1)/(Expr2^2);
Upsilon_1   =   xi_1*Expr1;
Upsilon_2   =   -Gamma_2+xi_2*Expr1+xi_ss*Expr3;
dphi_eds1=((s1_ss*Upsilon_1-xi_1)*domegabards1+Upsilon)/((xi_1-s1_ss*Upsilon_1)*domegabardphi_e);
chi_e=      phi_e_ss/dphi_eds1*(1/s1_ss);
chi_sigma=  -sigma_ss*(domegabardsigma*(Upsilon_1*s1_ss-xi_1)-xi_2+s1_ss*Upsilon_2)/(s1_ss*((s1_ss*Upsilon_1-xi_1)*domegabards1+Upsilon));

def_ss  =   Rk_ss/infl_ss*K_ss*mu*G_ss;
s_cris_ss=  def_ss*infl_ss/(K_ss-N_ss)+Rb_ss-R_ss;

phi_e_r_ss= (L_ss+N_ss)/N_ss;

model;
//Households
varrho_BGG*(1-beta*hh)*(1-hh)  = -(1+beta*hh^2)*C_BGG+hh*C_BGG(-1)+beta*hh*C_BGG(+1);
varrho_BGG=   varrho_BGG(+1)+R_gov_BGG-infl_BGG(+1);
R_BGG=R_gov_BGG-(1+hh)/(1-hh)*eps_c;

//wage setting
w_BGG   =   1/(1+beta)*(beta*w_BGG(+1)+w_BGG(-1)+beta*infl_BGG(+1)-(1+beta*gamma_W)*infl_BGG+gamma_W*infl_BGG(-1)-(1-xiw*beta)*(1-xiw)/(xiw*(1+epsilonw*varphi))*(w_BGG+varrho_BGG-varphi*l_BGG))+eps_w;
wm_BGG  =   w_BGG+varrho_BGG-varphi*l_BGG;

//retailers
infl_BGG =   1/(1+beta*gamma_P)*(beta*infl_BGG(+1)+gamma_P*infl_BGG(-1)+(1-xi*beta)*(1-xi)/xi*mc_BGG)+eps_p;
w_BGG+R_BGG*psi_l*R_ss/(1+psi_l*(R_ss-1))=   mc_BGG+Y_BGG-l_BGG;
rk_BGG/rk_ss+R_BGG*psi_k*R_ss/(1+psi_k*(R_ss-1))=   mc_BGG+Y_BGG-K_BGG(-1)-U_BGG;
L_r_BGG =   psi_l*w_ss*l_ss*(w_BGG+l_BGG)+psi_k*K_ss*rk_ss*(rk_BGG/rk_ss+U_BGG+K_BGG(-1));

//Capital Goods producing Sector
K_BGG   =   (1-delta)*K_BGG(-1)+delta*I_BGG+delta*(1+beta)*eta_i*a_I;
I_BGG   =   1/(1+beta)*(I_BGG(-1)+beta*I_BGG(+1)+Q_BGG/eta_i)+a_I;

//Banking Sector 
L_e_BGG =   phi_b_BGG+N_b_BGG;
z_BGG   =   R_ss*R_BGG(-1)/(z_ss*infl_ss)-infl_BGG;
N_b_BGG =   z_ss*theta_ss*z_BGG+z_ss*theta_ss*N_b_BGG(-1);
C_b_BGG =   z_BGG+N_b_BGG(-1);
Profratio_BGG=  z_ss*z_BGG;

//Entrepreneurial Sector
Rk_BGG  =   infl_BGG+infl_ss/Rk_ss*(rk_BGG+Q_BGG*(1-delta))-Q_BGG(-1);
rk_BGG  =   rk_ss*c_U*U_BGG;
Rk_BGG(+1)-R_BGG=   chi_e*phi_e_BGG+chi_sigma*sigma(+1);
phi_e_BGG=   Q_BGG+K_BGG-N_BGG;
ombar_BGG+Rk_BGG=   RL_BGG+1/(phi_e_ss-1)*phi_e_BGG(-1);
Rk_ss*Expr1*Rk_BGG+Rk_ss*Expr2*omegabar_ss*ombar_BGG+Rk_ss*Expr3*sigma_ss*sigma=R_ss*(phi_e_BGG(-1)/phi_e_ss+(phi_e_ss-1)/phi_e_ss*R_BGG(-1));
N_BGG   =   gamma*V_ss/N_ss*V_BGG; 
V_BGG-N_BGG(-1)=Rk_BGG-infl_BGG+phi_e_BGG(-1)-(omegabar_ss*Gamma_1*ombar_BGG+Gamma_2*sigma_ss*sigma)/(1-Gamma_ss)-e_N;
L_e_BGG-N_BGG=   phi_e_ss/(phi_e_ss-1)*phi_e_BGG;
C_e_BGG  =   V_BGG;
phi_e_r_BGG = (1-1/phi_e_r_ss)*(L_BGG-N_BGG);
N_shadow_BGG=gamma*((rk_BGG+Q_BGG*(1-delta))*(1-mu*G_ss)*phi_e_ss-phi_e_ss*Rk_ss/infl_ss*mu*G_1*omegabar_ss*ombar_BGG+phi_e_ss*Rk_ss/infl_ss*(1-mu*G_ss)*K_BGG(-1)-(R_BGG(-1)-infl_BGG)*R_ss/infl_ss*(phi_e_ss-1)-R_ss/infl_ss*(Q_BGG(-1)*phi_e_ss+phi_e_ss*K_BGG(-1)-N_BGG(-1)));
L_e_BGG_shadow*L_e_ss=Q_BGG*K_ss+K_BGG*K_ss-N_ss*N_shadow_BGG;

//Monetary Policy
R_gov_BGG*R_ss  =   (1-rho_i)*(kappa_pi*infl_BGG+kappa_Y*mc_BGG)+rho_i*R_ss*R_gov_BGG(-1)+e_i;

//Equilibrium
Y_BGG   =   alpha*(U_BGG+K_BGG(-1))+(1-alpha)*(a+l_BGG);
C_p_BGG =   C_ss/C_p_ss*C_BGG+C_e_ss/C_p_ss*C_e_BGG+C_b_ss/C_p_ss*C_b_BGG;
Y_BGG   =   I_ss/Y_ss*I_BGG+C_p_ss/Y_ss*C_p_BGG+govshare*g+Rk_ss/infl_ss*K_ss/Y_ss*mu*G_ss*(Rk_BGG-infl_BGG+Q_BGG(-1)+K_BGG(-1)+G_1/G_ss*omegabar_ss*ombar_BGG+G_2/G_ss*sigma_ss*sigma)+rk_ss*K_ss/Y_ss*U_BGG;
GDP_BGG =   I_ss/GDP_ss*I_BGG+C_p_ss/GDP_ss*C_p_BGG+Gov_ss/GDP_ss*g;
s2_4_BGG=   0;
s3_4_BGG=   4*(Rk_BGG(+1)-R_gov_BGG);
s4_4_BGG=   4*(RL_BGG(+1)-R_gov_BGG);
R_4_BGG =   4*R_gov_BGG;
Rk_4_BGG=   4*Rk_BGG;
infl_4_BGG= 4*infl_BGG;
L_BGG   =   1/L_ss*L_r_BGG+L_e_ss/L_ss*L_e_BGG;
Rat_BGG*L_ss/N_b_ss=   N_b_BGG-L_BGG;
k_BGG   =   K_BGG-l_BGG;

//Driving Processes
a       =   rho_a*a(-1)-e_a;
a_I     =   rho_a_I*a_I(-1)+e_a_I;
g       =   rho_g*g(-1)+e_g;
eps_p   =   rho_e_p*eps_p(-1)+e_p-mu_e_p*e_p(-1);   
eps_w   =   rho_e_w*eps_w(-1)+e_w-mu_e_w*e_w(-1); 
sigma   =   rho_sigma*sigma(-1)+e_sigma;
eps_c   =   rho_e_c*eps_c(-1)+e_c;

end;

initval;
Y_BGG   =   0;
GDP_BGG =   0;
I_BGG   =   0; 
K_BGG   =   0; 
l_BGG   =   0;
U_BGG   =   0; 
C_BGG   =   0;
C_e_BGG =   0;
C_p_BGG =   0;
varrho_BGG =0;
R_BGG   =   0;
R_gov_BGG=  0; 
Rk_BGG  =   0;
rk_BGG  =   0; 
RL_BGG  =   0;
w_BGG   =   0; 
a   =   0;
g   =   0; 
Q_BGG   =   0; 
infl_BGG=   0;
mc_BGG  =   0;
wm_BGG  =   0; 
N_BGG   =   0;
V_BGG   =   0; 
phi_e_BGG=  0;
phi_e_r_BGG=0;  
ombar_BGG=  0;
L_BGG   =   0;
L_r_BGG =   0;
L_e_BGG =   0;
N_b_BGG =   0;
phi_b_BGG=  0; 
z_BGG   =   0;
Rat_BGG =   0;
s2_4_BGG=   0;
s3_4_BGG=   0;
s4_4_BGG=   0;
R_4_BGG =   0;
Rk_4_BGG=   0;
infl_4_BGG =0;

end;
resid;
steady;


check;

shocks;

var e_a=(sd_a)^2;
var e_i=(sd_i)^2;
var e_g=(sd_g)^2;
var e_a_I=(sd_I_a_I)^2;
var e_N=sd_e_N^2;
var e_p=sd_e_p^2;
var e_w=sd_e_w^2;
var e_sigma=sd_e_sigma^2;
var e_c=sd_e_c^2;

end;

if      modtype==2;
            if MOM==1;
                    stoch_simul(order=1, irf=40, nograph, hp_filter=1600, ar=1) GDP_BGG C_p_BGG I_BGG l_BGG s4_4_BGG phi_e_r_BGG N_BGG Rat_BGG L_BGG N_b_BGG Profratio_BGG w_BGG phi_b_BGG L_BGG L_e_BGG R_4_BGG Rk_4_BGG infl_4_BGG s3_4_BGG s2_4_BGG Y_BGG Q_BGG K_BGG k_BGG Y_BGG mc_BGG C_BGG N_shadow_BGG L_e_BGG_shadow rk_BGG Rk_BGG;
            else;
                    stoch_simul(order=1, irf=40, nograph, nomoments) GDP_BGG C_p_BGG I_BGG l_BGG s4_4_BGG phi_e_r_BGG N_BGG Rat_BGG L_BGG N_b_BGG Profratio_BGG w_BGG phi_b_BGG L_BGG L_e_BGG R_4_BGG Rk_4_BGG infl_4_BGG s3_4_BGG s2_4_BGG Y_BGG Q_BGG K_BGG k_BGG Y_BGG mc_BGG C_BGG N_shadow_BGG L_e_BGG_shadow rk_BGG Rk_BGG;
            end; 
elseif modtype==6;
        stoch_simul(order=1, irf=40, nograph, nomoments) GDP_BGG C_p_BGG I_BGG l_BGG s4_4_BGG phi_e_r_BGG N_BGG Rat_BGG L_BGG N_b_BGG Profratio_BGG w_BGG phi_b_BGG L_BGG L_e_BGG R_4_BGG Rk_4_BGG infl_4_BGG s3_4_BGG s2_4_BGG Y_BGG Q_BGG K_BGG k_BGG Y_BGG mc_BGG C_BGG N_shadow_BGG L_e_BGG_shadow rk_BGG Rk_BGG;
end    
