%This file creates Figure 7 of the paper. It is called
%by the mastefile.

%Loads the model simulations
load temp_Crisis;


%loads the data, i.e. the deviation of real-percapita GDP, private consumption
%non-residential investment and loans (for details on datasources see
%appendix) from a quadratic trend from 2007Q2 to 2011Q4, normalized by the 
%deviation in 2007Q2, and the deviation of the external finance premium and
%the bank capital ration from their respective 2007Q1 values.
load Data_crisis;

periods=19;

time=[1:periods]';

GDP_data=GDP_data(1:periods,1);
Consumption_data=Consumption_data(1:periods,1);
Investment_data=Investment_data(1:periods,1);
BAA_spread=BAA_spread(1:periods,1);
Loans_data=Loans_data(1:periods,1);
Capital_Ratio_data=Capital_Ratio_data(1:periods,1);

%Crisis;
p=2;
q=3;

figure('Name','Crisis experiment');
axes('FontSize',8);
subplot(p,q,1)
plot(time,GDP_data(1:periods),'b-',time,GDP_Full_Crisis(1:periods),'g--',time,GDP_GK_Crisis(1:periods),'rs',time,GDP_BGG_Crisis(1:periods),'cx');
ylabel('%');
title('GDP','FontWeight','bold');
legend('Data','Full model','GK model','BGG model','Location','NorthEast');

subplot(p,q,2)
plot(time,Consumption_data(1:periods),'b-',time,C_p_Full_Crisis(1:periods),'g--',time,C_p_GK_Crisis(1:periods),'rs',time,C_p_BGG_Crisis(1:periods),'cx');
ylabel('%');
title('Consumption','FontWeight','bold');


subplot(p,q,3)
plot(time,Investment_data(1:periods),'b-',time,I_Full_Crisis(1:periods),'g--',time,I_GK_Crisis(1:periods),'rs',time,I_BGG_Crisis(1:periods),'cx');
ylabel('%');
title('Investment','FontWeight','bold');


subplot(p,q,4)
plot(time,BAA_spread(1:periods),'b-',time,s4_4_Full_Crisis(1:periods),'g--',time,s2_4_GK_Crisis(1:periods),'rs',time,s4_4_BGG_Crisis(1:periods),'cx');
ylabel('%');
title('R^L_{t}-R_t','FontWeight','bold');

subplot(p,q,5)
plot(time,Loans_data(1:periods),'b-',time,L_Full_Crisis(1:periods),'g--',time,L_GK_Crisis(1:periods),'rs',time,L_BGG_Crisis(1:periods),'cx');
ylabel('%');
title('Loans','FontWeight','bold');

subplot(p,q,6)
plot(time,Capital_Ratio_data(1:periods),'b-',time,Rat_Full_Crisis(1:periods),'g--',time,Rat_GK_Crisis(1:periods),'rs');
ylabel('%');
title('Capital Ratio','FontWeight','bold');






