%This file creates figure 4 in the paper (note that since it plots results from a stochastic simulation is 
%results will not look excactly the same as in the manuscript. It is called
%by the mastefile. 


clear all;
p=2;
q=2;

dynare Fullmod_dep_crisis noclearall;

figure('Name','Growth rate of leverage and assets in banking and non-financial sector');
axes('FontSize',8);
subplot(p,q,1)
scatter(g_phi_b_Full,g_Ab_Full)
ylabel('Growth rate of assets');
xlabel('Growth rate of leverage');
title('Full model, banking sector','FontWeight','bold');

subplot(p,q,2)
scatter(g_phi_e_r_Full,g_Ae_Full)
ylabel('Growth rate of assets');
xlabel('Growth rate of leverage');
title('Full model, non-financial sector','FontWeight','bold');

dynare GK_dep noclearall;


subplot(p,q,3)
scatter(g_phi_b_GK,g_Ab_GK)
ylabel('Growth rate of assets');
xlabel('Growth rate of leverage');
title('GK model, banking sector','FontWeight','bold');

subplot(p,q,4)
scatter(g_Ab_Fair_GK, g_phi_b_Fair_GK)
ylabel('Growth rate of assets');
xlabel('Growth rate of leverage');
title('GK model, banking sector, fair value','FontWeight','bold');

