%This file creates figures 1, 2, 5 and 6. It is called by the masterfile.

time=[1:40]';
load temp_Full_IRF;
load temp_BGG_IRF;
load temp_GK_IRF;
load temp_nofr_IRF;

%Plot Monetary policy shock;
p=2;
q=3;

figure('Name','Monetary policy shock a');
axes('FontSize',8);
subplot(p,q,1)
plot(time,GDP_Full_e_i,'b-',time,GDP_BGG_e_i,'g--',time,GDP_GK_e_i,'r:',time,GDP_nofr_e_i,'c-o');
ylabel('%');
title('GDP','FontWeight','bold');
legend('Full','BGG','GK','nofriction','Location','SouthEast');

subplot(p,q,2)
plot(time,C_p_Full_e_i,'b-',time,C_p_BGG_e_i,'g--',time,C_p_GK_e_i,'r:',time,C_p_nofr_e_i,'c-o');
axis([0 40 -0.4 0.05])
ylabel('%');
title('Consumption','FontWeight','bold');

subplot(p,q,3)
plot(time,I_Full_e_i,'b-',time,I_BGG_e_i,'g--',time,I_GK_e_i,'r:',time,I_nofr_e_i,'c-o');
axis([0 40 -1.4 0.25])
ylabel('%');
title('Investment','FontWeight','bold');

subplot(p,q,4)
plot(time,Q_Full_e_i,'b-',time,Q_BGG_e_i,'g--',time,Q_GK_e_i,'r:',time,Q_nofr_e_i,'c-o');
axis([0 40 -1.2 0.1])
ylabel('%');
title('Q','FontWeight','bold');

subplot(p,q,5)
plot(time,infl_4_Full_e_i,'b-',time,infl_4_BGG_e_i,'g--',time,infl_4_GK_e_i,'r:',time,infl_4_nofr_e_i,'c-o');
axis([0 40 -0.8 0.1])
ylabel('APR');
title('Inflation','FontWeight','bold');

subplot(p,q,6)
plot(time,R_4_Full_e_i,'b-',time,R_4_BGG_e_i,'g--',time,R_4_GK_e_i,'r:',time,R_4_nofr_e_i,'c-o');
ylabel('APR');
title('Deposit/Policy interest rate','FontWeight','bold');

p=2;
q=3;

figure('Name','Monetary policy shock b');
subplot(p,q,1)
plot(time,L_e_Full_e_i,'b-',time,N_Full_e_i,'g--',time,phi_b_Full_e_i,'r:',time,N_b_Full_e_i,'c-o');
ylabel('%');
title('Full model: L^e, N, phi^b and N^b','FontWeight','bold');
legend('L^e','N','phi^b','N^b','Location','SouthEast');

subplot(p,q,2)
plot(time,L_e_BGG_e_i,'b-',time,N_BGG_e_i,'g--',time,phi_b_BGG_e_i,'r:',time,N_b_BGG_e_i,'c-o');
ylabel('%');
title('BGG model: L^e, N, phi^b and N^b','FontWeight','bold');
legend('L^e','N','phi^b','N^b','Location','SouthEast');

subplot(p,q,3)
plot(time,L_e_GK_e_i,'b-',time,phi_b_GK_e_i,':r',time,N_b_GK_e_i,'-oc');
ylabel('%');
title('GK model: L^e, phi^b and N^b','FontWeight','bold');
legend('L^e','phi^b','N^b','Location','SouthEast');

subplot(p,q,4)
plot(time,s3_4_Full_e_i,'b-',time,s3_4_BGG_e_i,'g--',time,s3_4_GK_e_i,'r:',time,s2_4_Full_e_i,'c-o',time,s3_4_Full_e_i-s2_4_Full_e_i,'m-x');
ylabel('APR');
title('All models: R^k_{t+1}-R_t and banking sector profit margin','FontWeight','bold');
legend('Full: R^k_{t+1}-R_t','BGG: R^k_{t+1}-R_t ','GK: R^k_{t+1}-R_t','Full: R^b_{t+1}-R_t','Full: R^k_{t+1}-R^b_{t+1}');

subplot(p,q,5)
plot(time,L_Full_e_i,'b-',time,L_BGG_e_i,'g--',time,L_GK_e_i,'r:',time,L_nofr_e_i,'c-o');
ylabel('%');
title('All models: Loans','FontWeight','bold');
legend('Full','BGG','GK','nofriction','Location','SouthEast');

subplot(p,q,6)
plot(time,Rat_Full_e_i,'b-',time,Rat_BGG_e_i,'g--',time,Rat_GK_e_i,'r:');
axis([0 40 -0.8 0.4])
ylabel('PP');
title('All models: Capital ratio','FontWeight','bold');
legend('Full','BGG','GK','Location','SouthEast');

%Plot Productivity shock;
p=2;
q=3;

figure('Name','Productivity shock a');
axes('FontSize',8);
subplot(p,q,1)
plot(time,GDP_Full_e_a,'b-',time,GDP_BGG_e_a,'g--',time,GDP_GK_e_a,'r:',time,GDP_nofr_e_a,'c-o');
ylabel('%');
title('GDP','FontWeight','bold');
legend('Full','BGG','GK','nofriction','Location','SouthEast');

subplot(p,q,2)
plot(time,C_p_Full_e_a,'b-',time,C_p_BGG_e_a,'g--',time,C_p_GK_e_a,'r:',time,C_p_nofr_e_a,'c-o');
axis([0 40 -0.6 0])
ylabel('%');
title('Consumption','FontWeight','bold');

subplot(p,q,3)
plot(time,I_Full_e_a,'b-',time,I_BGG_e_a,'g--',time,I_GK_e_a,'r:',time,I_nofr_e_a,'c-o');
axis([0 40 -2.5 0.2]);
ylabel('%');
title('Investment','FontWeight','bold');

subplot(p,q,4)
plot(time,Q_Full_e_a,'b-',time,Q_BGG_e_a,'g--',time,Q_GK_e_a,'r:',time,Q_nofr_e_a,'c-o');
axis([0 40 -1 0.2]);
ylabel('%');
title('Q','FontWeight','bold');

subplot(p,q,5)
plot(time,infl_4_Full_e_a,'b-',time,infl_4_BGG_e_a,'g--',time,infl_4_GK_e_a,'r:',time,infl_4_nofr_e_a,'c-o');
ylabel('APR');
title('Inflation','FontWeight','bold');

subplot(p,q,6)
plot(time,R_4_Full_e_a,'b-',time,R_4_BGG_e_a,'g--',time,R_4_GK_e_a,'r:',time,R_4_nofr_e_a,'c-o');
ylabel('APR');
title('Deposit/Policy interest rate','FontWeight','bold');

figure('Name','Productivity shock b');

subplot(p,q,1)
plot(time,L_e_Full_e_a,'b-',time,N_Full_e_a,'g--',time,phi_b_Full_e_a,'r:',time,N_b_Full_e_a,'c-o');
ylabel('%');
title('Full model: L^e, N, phi^b and N^b','FontWeight','bold');
legend('L^e','N','phi^b','N^b','Location','SouthEast');

subplot(p,q,2)
plot(time,L_e_BGG_e_a,'b-',time,N_BGG_e_a,'g--',time,phi_b_BGG_e_a,'r:',time,N_b_BGG_e_a,'c-o');
ylabel('%');
title('BGG model: L^e, N, phi^b and N^b','FontWeight','bold');
legend('L^e','N','phi^b','N^b');

subplot(p,q,3)
plot(time,L_e_GK_e_a,'b-',time,phi_b_GK_e_a,':r',time,N_b_GK_e_a,'-oc');
ylabel('%');
title('GK model: L^e, phi^b and N^b','FontWeight','bold');
legend('L^e','phi^b','N^b');

subplot(p,q,4)
plot(time,s3_4_Full_e_a,'b-',time,s3_4_BGG_e_a,'g--',time,s3_4_GK_e_a,'r:',time,s2_4_Full_e_a,'c-o',time,s3_4_Full_e_a-s2_4_Full_e_a,'m-x');
ylabel('APR');
title('All models: R^k_{t+1}-R_t and banking sector profit margin','FontWeight','bold');
legend('Full: R^k_{t+1}-R_t','BGG: R^k_{t+1}-R_t ','GK: R^k_{t+1}-R_t','Full: R^b_{t+1}-R_t', 'Full: R^k_{t+1}-R^b_{t+1}');

subplot(p,q,5)
plot(time,L_Full_e_a,'b-',time,L_BGG_e_a,'g--',time,L_GK_e_a,'r:',time,L_nofr_e_a,'c-o');
ylabel('%');
title('All models: Loans','FontWeight','bold');
legend('Full','BGG','GK','nofriction','Location','SouthEast');

subplot(p,q,6)
plot(time,Rat_Full_e_a,'b-',time,Rat_BGG_e_a,'g--',time,Rat_GK_e_a,'r:');
ylabel('PP');
title('All models: Capital ratio','FontWeight','bold');
legend('Full','BGG','GK','Location','SouthEast');


%Plot Entrepreneurial net worth shock;
p=2;
q=3;

figure('Name','-1% Entrepreneurial net worth shock, a');
axes('FontSize',8);
subplot(p,q,1)
plot(time,GDP_Full_e_N,'b-',time,GDP_BGG_e_N,'g--');
ylabel('%');
title('GDP','FontWeight','bold');
legend('Full','BGG','Location','SouthEast');

subplot(p,q,2)
plot(time,C_p_Full_e_N,'b-',time,C_p_BGG_e_N,'g--');
ylabel('%');
title('Consumption','FontWeight','bold');

subplot(p,q,3)
plot(time,I_Full_e_N,'b-',time,I_BGG_e_N,'g--');
ylabel('%');
title('Investment','FontWeight','bold');

subplot(p,q,4)
plot(time,Q_Full_e_N,'b-',time,Q_BGG_e_N,'g--');
ylabel('%');
title('Q','FontWeight','bold');

subplot(p,q,5)
plot(time,infl_4_Full_e_N,'b-',time,infl_4_BGG_e_N,'g--');
ylabel('APR');
title('Inflation','FontWeight','bold');

subplot(p,q,6)
plot(time,R_4_Full_e_N,'b-',time,R_4_BGG_e_N,'g--');
ylabel('APR');
title('Deposit/Policy interest rate','FontWeight','bold');

figure('Name','-1% Entrepreneurial net worth shock, b');

subplot(p,q,1)
plot(time,L_e_Full_e_N,'b-',time,N_Full_e_N,'g--',time,phi_b_Full_e_N,'r:',time,N_b_Full_e_N,'c-o');
ylabel('%');
title('Full model: L^e, N, phi^b and N^b','FontWeight','bold');
legend('L^e','N','phi^b','N^b','Location','SouthEast');

subplot(p,q,2)
plot(time,L_e_BGG_e_N,'b-',time,N_BGG_e_N,'g--',time,phi_b_BGG_e_N,'r:',time,N_b_BGG_e_N,'c-o');
ylabel('%');
title('BGG model: L^e, N, phi^b and N^b','FontWeight','bold');
legend('L^e','N','phi^b','N^b','Location','SouthEast');

subplot(p,q,3)
plot(time,s3_4_Full_e_N,'b-',time,s3_4_BGG_e_N,'g--',time,s2_4_Full_e_N,'r-o',time,s3_4_Full_e_N-s2_4_Full_e_N,'m-x');
ylabel('APR');
title('All models: R^k_{t+1}-R_t and banking sector profit margin','FontWeight','bold');
legend('Full: R^k_{t+1}-R_t','BGG: R^k_{t+1}-R_t ','Full: R^b_{t+1}-R_t','Full: R^k_{t+1}-R^b_{t+1}');

subplot(p,q,5)
plot(time,L_Full_e_N,'b-',time,L_BGG_e_N,'g--');
ylabel('%');
title('All models: Loans','FontWeight','bold');
legend('Full','BGG');

subplot(p,q,6)
plot(time,Rat_Full_e_N,'b-',time,Rat_BGG_e_N,'g--');
axis([0 40 -0.2 1]);
ylabel('PP');
title('All models: Capital ratio','FontWeight','bold');
legend('Full','BGG');


%Plot Bank net worth shock;
p=2;
q=3;

figure('Name','-5% Bank net worth shock a');
axes('FontSize',8);
subplot(p,q,1)
plot(time,GDP_Full_e_z,'b-',time,GDP_GK_e_z,'g--');
ylabel('%');
title('GDP','FontWeight','bold');
legend('Full','GK','Location','SouthEast');

subplot(p,q,2)
plot(time,C_p_Full_e_z,'b-',time,C_p_GK_e_z,'g--');
axis([0 40 -0.2 0.1])
ylabel('%');
title('Consumption','FontWeight','bold');

subplot(p,q,3)
plot(time,I_Full_e_z,'b-',time,I_GK_e_z,'g--');
ylabel('%');
title('Investment','FontWeight','bold');

subplot(p,q,4)
plot(time,Q_Full_e_z,'b-',time,Q_GK_e_z,'g--');
ylabel('%');
title('Q','FontWeight','bold');

subplot(p,q,5)
plot(time,infl_4_Full_e_z,'b-',time,infl_4_GK_e_z,'g--');
ylabel('APR');
title('Inflation','FontWeight','bold');

subplot(p,q,6)
plot(time,R_4_Full_e_z,'b-',time,R_4_GK_e_z,'g--');
ylabel('APR');
title('Deposit/Policy interest rate','FontWeight','bold');


figure('Name','-5% Bank net worth shock b');

subplot(p,q,1)
plot(time,L_e_Full_e_z,'b-',time,N_Full_e_z,'g--',time,phi_b_Full_e_z,'r:',time,N_b_Full_e_z,'c-o');
ylabel('%');
title('Full model: L^e, N, phi^b and N^b','FontWeight','bold');
legend('L^e','N','phi^b','N^b');

subplot(p,q,2)
plot(time,L_e_GK_e_z,'b-',time,N_GK_e_z,'g--',time,phi_b_GK_e_z,'r:',time,N_b_GK_e_z,'c-o');
ylabel('%');
title('GK model: L^e, N, phi^b and N^b','FontWeight','bold');
legend('L^e','N','phi^b','N^b');

subplot(p,q,3)
plot(time,s3_4_Full_e_z,'b-',time,s3_4_GK_e_z,'g--',time,s2_4_Full_e_z,'r-o',time,s3_4_Full_e_z-s2_4_Full_e_z,'m-x');
ylabel('APR');
title('All models: R^k_{t+1}-R_t and banking sector profit margin','FontWeight','bold');
legend('Full: R^k_{t+1}-R_t','GK: R^k_{t+1}-R_t ','Full: R^b_{t+1}-R_t','Full: R^k_{t+1}-R^b_{t+1}');

subplot(p,q,4)
plot(time,L_Full_e_z,'b-',time,L_GK_e_z,'g--');
axis([0 40 -0.6 0])
ylabel('%');
title('All models: Loans','FontWeight','bold');
legend('Full','GK','Location','SouthEast');

subplot(p,q,5)
plot(time,Rat_Full_e_z,'b-',time,Rat_GK_e_z,'g--');
ylabel('PP');
title('All models: Capital ratio','FontWeight','bold');
legend('Full','GK','Location','SouthEast');

