Var Y_Full GDP_Full I_Full K_Full l_Full U_Full C_Full C_e_Full C_p_Full C_b_Full C_nr_Full varrho_Full R_Full R_gov_Full Rk_Full rk_Full Rb_Full RL_Full w_Full a a_I g sigma s_z lambda Q_Full infl_Full mc_Full wm_Full N_Full V_Full phi_e_Full phi_e_r_Full om_pr_Full L_Full L_r_Full L_e_Full N_b_Full phi_b_Full z_Full Profratio_Full Profits_Full Rat_Full s1_4_Full s2_4_Full s3_4_Full s4_4_Full R_4_Full Rk_4_Full infl_4_Full k_Full Ae_Full g_Ae_Full g_Ab_Full g_phi_e_r_Full g_phi_b_Full g_GDP_Full;
Var eps_p eps_w eps_c;
varexo e_z e_N e_a e_i e_g e_a_I e_N_b e_Rb e_lambda e_p e_w e_sigma e_c;

parameters alpha delta beta chi c_U psi_k psi_l varphi s_nr hh eta_i xi gamma_P kappa_pi kappa_dpi kappa_X kappa_GDP kappa_Y rho_i rho_g rho_a rho_a_I rho_sigma rho_e_lambda rho_e_p mu_e_p rho_e_w mu_e_w rho_e_c epsilon mu epsilonw xiw gamma_W sigma_ss brate gamma We Theta Thetab pin theta_ss lambda_ss chi_e chi_sigma;
parameters Y_ss GDP_ss K_ss YK_ss l_ss C_ss C_e_ss C_p_ss C_b_ss C_nr_ss I_ss Gov_ss govshare R_ss varrho_ss Rk_ss rk_ss Rb_ss RL_ss s1_ss s2_ss s_cris_ss Pm_ss k_ss w_ss X_ss infl_ss S_ss N_ss V_ss phi_e_ss phi_e_r_ss omegabar_ss tromegabar_ss omega_pr_ss F_ss Gamma_ss Gamma_1 Gamma_2 G_ss G_1 G_2 def_ss xi_ss L_ss L_r_ss L_e_ss Expr1 Expr2 Expr3 N_b_ss Nbe_ss Nbn_ss v_ss eta_ss x_ss z_ss phi_b_ss;

load temp1;
load temp_simtype;

//Households
beta    =   p_Full(1);
hh       =  p_Full(2);
varphi  =   p_Full(3);
s_nr    =   p_Full(4);

//Wage Setting;
epsilonw=   p_Full(5);
xiw     =   p_Full(6);
gamma_W =   p_Full(7);

//Entrepreneurs
alpha   =   p_Full(8);
delta   =   p_Full(9);
sigma_ss=   p_Full(10);
pin     =   p_Full(11);
Theta   =   p_Full(12);
gamma   =   p_Full(13);
c_U     =   p_Full(14);
psi_k   =   p_Full(15);
psi_l   =   p_Full(16);
mu      =   p_Full(17);

//bankers
theta_ss =  p_Full(18);
Thetab  =   p_Full(19);

//Capital good's producers
eta_i   =   p_Full(20);

//Retailers
xi      =   p_Full(21);
gamma_P =   p_Full(22);
epsilon =   p_Full(23);
S_ss    =   p_Full(24);

//Monetary Policy
kappa_pi=   p_Full(25);
kappa_dpi=  p_Full(26);
kappa_X =   p_Full(27);
kappa_Y =   p_Full(28);
rho_i   =   p_Full(29);
kappa_GDP=  p_Full(30);

//shock process
rho_a   =   p_Full(31);
rho_g   =   p_Full(32);
rho_a_I =   p_Full(33);
rho_e_lambda=p_Full(34);
rho_e_c =   p_Full(35);
sd_a    =   p_Full(36);
sd_i    =   p_Full(37);
sd_g    =   p_Full(38);
sd_I_a_I=   p_Full(39);
sd_e_N  =   p_Full(40);
sd_e_z  =   p_Full(41);
sd_e_lambda=p_Full(42);
sd_e_c  =   p_Full(43);

//calibrated Steady State Values
infl_ss =   p_Full(44);
govshare=   p_Full(45);
s2_ss   =   p_Full(46);
l_ss    =   p_Full(47);            
phi_b_ss=   p_Full(48);          
brate   =   p_Full(49);

//shock processes continued 
sd_e_p  =   p_Full(50);
rho_e_p =   p_Full(51);
mu_e_p  =   p_Full(52);

sd_e_w  =   p_Full(53);
rho_e_w =   p_Full(54);
mu_e_w  =   p_Full(55);

sd_e_sigma  = p_Full(56);
rho_sigma =   p_Full(57);


//Steady State
R_ss    =   1/beta*infl_ss;

//Most variables and backed out parameters pertaining to the entrepreneurial sector
omegabar_ss=   exp(sigma_ss*norminv(brate,0,1)-0.5*sigma_ss^2); // cut off value of omega
tromegabar_ss= (log(omegabar_ss)+0.5*sigma_ss^2)/sigma_ss;
F_ss    =   normcdf(tromegabar_ss,0,1);
F_1     =   1/(omegabar_ss*sigma_ss)*normpdf(tromegabar_ss,0,1);
F_11    =   -F_1/omegabar_ss*(1+(log(omegabar_ss)+0.5*sigma_ss^2)/sigma_ss^2);
F_12    =   -F_1/sigma_ss*(1+(0.25*sigma_ss^4-(log(omegabar_ss))^2)/sigma_ss^2);
F_2     =   (0.5*sigma_ss^2-log(omegabar_ss))/sigma_ss^2*normpdf(tromegabar_ss,0,1);
G_ss    =   normcdf(tromegabar_ss-sigma_ss);
G_1    =    omegabar_ss*F_1;
G_11    =   F_1+omegabar_ss*F_11;
G_12    =   omegabar_ss*F_12;
G_2     =   ((0.5*sigma_ss^2-log(omegabar_ss))/sigma_ss^2-1)*normpdf(tromegabar_ss-sigma_ss,0,1);
Gamma_ss  =   omegabar_ss*(1-F_ss)+G_ss; //Tau is capital gamma
Gamma_1   =   1-F_ss;
Gamma_2   =   -omegabar_ss*F_2+G_2;
Gamma_11  =   -F_1;
Gamma_12  =   -F_2;
Expr1   =   Gamma_ss-mu*G_ss;
Expr2   =   Gamma_1-mu*G_1;
Expr3   =   Gamma_2-mu*G_2;
xi_ss =   Gamma_1/Expr2;    //Lagrange multiplier from Entrepreneur maximisation problem
s1_ss   =   Gamma_1/(Gamma_1-mu*(G_1*(1-Gamma_ss)+Gamma_1*G_ss)); //Rk_ss/Rb_ss
phi_e_ss=   1/(1-Expr1*s1_ss);   
Rb_ss   =   R_ss*s2_ss;
Rk_ss   =   Rb_ss*s1_ss;
RL_ss   =   omegabar_ss*Rk_ss/(1-1/phi_e_ss);

//most real variables
X_ss    =   epsilon/(epsilon-1); //markup of retailers
rk_ss   =   Rk_ss/infl_ss-(1-delta);
Pm_ss   =   1/X_ss; 
Q_ss    =   1;
k_ss    =   (alpha/(X_ss*(1+psi_k*(R_ss-1))*(Rk_ss/infl_ss-1+delta)))^(1/(1-alpha));
w_ss    =   1/(X_ss*(1+psi_l*(R_ss-1)))*(1-alpha)*k_ss^alpha;
YK_ss   =   X_ss/alpha*(Rk_ss/infl_ss-1+delta)*(1+psi_k*(R_ss-1));
K_ss    =   l_ss*k_ss;
Y_ss     =  YK_ss*K_ss;
Gov_ss  =   govshare*Y_ss;
I_ss    =   delta*K_ss;

//Remaining entrepreneurial variables
omega_pr_ss=   omegabar_ss*Rk_ss;
V_ss    =   K_ss*Rk_ss/infl_ss*(1-Gamma_ss);
N_ss    =   K_ss/phi_e_ss;
L_e_ss  =   K_ss-N_ss;
L_r_ss  =   psi_k*rk_ss*K_ss+psi_l*w_ss*l_ss; //loans to retailers
L_ss    =   L_r_ss+L_e_ss;
We      =   N_ss-gamma*V_ss; //Transfer to new entrepreneurs

//Banking Sector variables and backed out parameters
z_ss    =   ((Rb_ss-R_ss)*phi_b_ss+R_ss)/infl_ss;
x_ss    =   z_ss;
eta_ss  =   (1-theta_ss)/(1-beta*theta_ss*x_ss);
v_ss    =   (1-theta_ss)*1/R_ss*(Rb_ss-R_ss)/(1-beta*theta_ss*z_ss);
lambda_ss=   (eta_ss+phi_b_ss*v_ss)/phi_b_ss;  //share of loans to entrepreneurs bankers can divert
N_b_ss  =   L_e_ss/phi_b_ss;
Nbe_ss  =   theta_ss*z_ss*N_b_ss; //Net worth of existing banks
Nbn_ss  =   N_b_ss-Nbe_ss;

//Consumption, GDP
C_e_ss  =   (1-gamma)*Theta*V_ss;
C_b_ss  =   Thetab*(1-theta_ss)*z_ss*N_b_ss;
C_nr_ss =   l_ss*w_ss*s_nr;
C_ss    =   Y_ss-C_nr_ss-I_ss-Gov_ss-C_e_ss-C_b_ss-mu*G_ss*Rk_ss/infl_ss*K_ss;
C_p_ss  =   C_ss+C_nr_ss+C_e_ss+C_b_ss;
GDP_ss  =   C_p_ss+I_ss+Gov_ss;
varrho_ss=  1/(C_ss*(1-hh)); //lagrange multiplier on the representative ricardian households budget constraint
chi     =   varrho_ss*w_ss/l_ss^varphi*(epsilonw-1)/epsilonw; // backed out parameter: weight of labour in utility function

//Calculation of coefficient on entrepreneurial leverage chi_e and on sigma chi_sigma
Upsilon     =   1-Gamma_ss+xi_ss*Expr1; 
domegabards1=-Expr1/(Expr2*s1_ss);
domegabardphi_e=(1-Expr1*s1_ss)/(Expr2*s1_ss*phi_e_ss);
domegabardsigma=-Expr3/Expr2;
psi_1  =   mu*(Gamma_1*G_11-Gamma_11*G_1)/(Expr2^2);
psi_2  =   mu*(Gamma_1*G_12-Gamma_12*G_1)/(Expr2^2);
Upsilon_1   =   psi_1*Expr1;
Upsilon_2   =   -Gamma_2+psi_2*Expr1+xi_ss*Expr3;
dphi_eds1=((s1_ss*Upsilon_1-psi_1)*domegabards1+Upsilon)/((psi_1-s1_ss*Upsilon_1)*domegabardphi_e);
chi_e=      phi_e_ss/dphi_eds1*(1/s1_ss);
chi_sigma=  -sigma_ss*(domegabardsigma*(Upsilon_1*s1_ss-psi_1)-psi_2+s1_ss*Upsilon_2)/(s1_ss*((s1_ss*Upsilon_1-psi_1)*domegabards1+Upsilon));

def_ss  =   Rk_ss/infl_ss*K_ss*mu*G_ss;
s_cris_ss=  def_ss*infl_ss/(K_ss-N_ss)+Rb_ss-R_ss;

phi_e_r_ss= (L_ss+N_ss)/N_ss;

model (linear);
//Households
varrho_Full*(1-beta*hh)*(1-hh)  = -(1+beta*hh^2)*C_Full+hh*C_Full(-1)+beta*hh*C_Full(+1);
varrho_Full=   varrho_Full(+1)+R_gov_Full-infl_Full(+1);
R_Full=R_gov_Full-(1+hh)/(1-hh)*eps_c;
C_nr_Full  =   l_Full+w_Full;

//wage setting
w_Full  =   1/(1+beta)*(beta*w_Full(+1)+w_Full(-1)+beta*infl_Full(+1)-(1+beta*gamma_W)*infl_Full+gamma_W*infl_Full(-1)-(1-xiw*beta)*(1-xiw)/(xiw*(1+epsilonw*varphi))*(w_Full+varrho_Full-varphi*l_Full))+eps_w;
wm_Full =   w_Full+varrho_Full-varphi*l_Full;

//retailers
infl_Full=   1/(1+beta*gamma_P)*(beta*infl_Full(+1)+gamma_P*infl_Full(-1)+(1-xi*beta)*(1-xi)/xi*mc_Full)+eps_p;
w_Full+R_Full*psi_l*R_ss/(1+psi_l*(R_ss-1))=   mc_Full+Y_Full-l_Full;
rk_Full/rk_ss+R_Full*psi_k*R_ss/(1+psi_k*(R_ss-1))=   mc_Full+Y_Full-K_Full(-1)-U_Full;
L_r_Full=   psi_l*w_ss*l_ss*(w_Full+l_Full)+psi_k*K_ss*rk_ss*(rk_Full/rk_ss+U_Full+K_Full(-1));

//Capital Goods producing Sector
K_Full  =   (1-delta)*K_Full(-1)+delta*I_Full+delta*(1+beta)*eta_i*a_I;
I_Full  =   1/(1+beta)*(I_Full(-1)+beta*I_Full(+1)+Q_Full/eta_i)+a_I;


//Banking Sector 
L_e_Full=   phi_b_Full+N_b_Full;
phi_b_Full= theta_ss*beta^2*z_ss^2*phi_b_Full(+1)+phi_b_ss*Rb_ss/R_ss*(Rb_Full(+1)-R_Full)-theta_ss*beta^2*z_ss^2*s_z(+1)-phi_b_ss*lambda_ss/eta_ss*(lambda-theta_ss*beta*z_ss*lambda(+1));   
z_Full  =   (phi_b_ss*(Rb_ss*Rb_Full-R_ss*R_Full(-1))+phi_b_ss*(Rb_ss-R_ss)*phi_b_Full(-1)+R_ss*R_Full(-1))/(z_ss*infl_ss)-infl_Full-s_z;
N_b_Full=   z_ss*theta_ss*(z_Full+N_b_Full(-1)-e_N_b);
C_b_Full=   z_Full+N_b_Full(-1)-e_N_b;
Profratio_Full=  z_ss*z_Full;
Profits_Full =  z_ss/(z_ss-1)*z_Full+N_b_Full(-1);

//Entrepreneurial Sector
Rk_Full =   infl_Full+infl_ss/Rk_ss*(rk_Full+Q_Full*(1-delta))-Q_Full(-1);
rk_Full =   rk_ss*c_U*U_Full;
Rk_Full(+1)-Rb_Full(+1)=chi_e*phi_e_Full+chi_sigma*sigma(+1);
phi_e_Full= Q_Full+K_Full-N_Full;
om_pr_Full= RL_Full+1/(phi_e_ss-1)*phi_e_Full;
-Rk_ss*Expr1*e_Rb+(Rk_ss*Expr1-omega_pr_ss*Expr2)*Rk_Full+Expr2*omega_pr_ss*om_pr_Full(-1)+Rk_ss*Expr3*sigma_ss*sigma=Rb_ss*(phi_e_Full(-1)/phi_e_ss+(phi_e_ss-1)/phi_e_ss*Rb_Full);
N_Full  =   gamma*V_ss/N_ss*V_Full;
V_Full-N_Full(-1)=   Rk_Full-infl_Full+phi_e_Full(-1)-(omegabar_ss*Gamma_1*(om_pr_Full(-1)-Rk_Full)+Gamma_2*sigma_ss*sigma)/(1-Gamma_ss)-e_N; 
L_e_Full-N_Full=phi_e_ss/(phi_e_ss-1)*phi_e_Full;
C_e_Full=   V_Full;
phi_e_r_Full = (1-1/phi_e_r_ss)*(L_Full-N_Full);


//Monetary Policy
R_gov_Full*R_ss  =   (1-rho_i)*(kappa_pi*infl_Full+kappa_Y*mc_Full)+rho_i*R_ss*R_gov_Full(-1)+e_i;

//Equilibrium
Y_Full  =   alpha*(U_Full+K_Full(-1))+(1-alpha)*(a+l_Full);
C_p_Full=   C_ss/C_p_ss*C_Full+C_nr_ss/C_p_ss*C_nr_Full+C_b_ss/C_p_ss*C_b_Full+C_e_ss/C_p_ss*C_e_Full;
Y_Full  =   I_ss/Y_ss*I_Full+C_p_ss/Y_ss*C_p_Full+govshare*g+Rk_ss/infl_ss*K_ss/Y_ss*mu*G_ss*(Rk_Full-infl_Full+Q_Full(-1)+K_Full(-1)+G_1/G_ss*omegabar_ss*(om_pr_Full(-1)-Rk_Full)+G_2/G_ss*sigma_ss*sigma)+rk_ss*K_ss/Y_ss*U_Full;
GDP_Full=   I_ss/GDP_ss*I_Full+C_p_ss/GDP_ss*C_p_Full+Gov_ss/GDP_ss*g;
s1_4_Full=  4*(Rk_Full(+1)-Rb_Full(+1));
s2_4_Full=  4*(Rb_Full(+1)-R_gov_Full);
s3_4_Full=   4*(Rk_Full(+1)-R_gov_Full);
s4_4_Full=   4*(RL_Full-R_gov_Full);
R_4_Full=   4*R_gov_Full;
Rk_4_Full=   4*Rk_Full;
infl_4_Full=   4*infl_Full;
L_Full  =   1/L_ss*L_r_Full+L_e_ss/L_ss*L_e_Full;
Rat_Full*L_ss/N_b_ss=   N_b_Full-L_Full;
k_Full  =   K_Full-l_Full;
Ae_Full      =  (Q_Full+K_ss*K_Full+L_r_ss*L_r_Full)/(K_ss+L_r_ss);
g_Ae_Full    =   Ae_Full-Ae_Full(-1);
g_Ab_Full    =   L_Full-L_Full(-1);
g_phi_e_r_Full=   phi_e_r_Full-phi_e_r_Full(-1);
g_phi_b_Full =   (-Rat_Full+Rat_Full(-1))*L_ss/N_b_ss;
g_GDP_Full   =   GDP_Full-GDP_Full(-1); 

//Driving Processes
a       =   rho_a*a(-1)-e_a;
a_I     =   rho_a_I*a_I(-1)+e_a_I;
g       =   rho_g*g(-1)+e_g;
eps_p   =   rho_e_p*eps_p(-1)+e_p-mu_e_p*e_p(-1);   
eps_w   =   rho_e_w*eps_w(-1)+e_w-mu_e_w*e_w(-1);
s_z     =   e_z;
lambda  =   rho_e_lambda*lambda(-1)+e_lambda;
sigma   =   rho_sigma*sigma(-1)+e_sigma;
eps_c   =   rho_e_c*eps_c(-1)+e_c;

end;

initval;
Y_Full  =   0;
GDP_Full=   0;
I_Full  =   0; 
K_Full  =   0; 
l_Full  =   0;
U_Full  =   0; 
C_Full  =   0;
C_e_Full=   0;
C_p_Full=   0;
C_b_Full=   0;
C_nr_Full=  0; 
varrho_Full=0;
R_Full  =   0; 
Rk_Full =   0;
rk_Full =   0; 
Rb_Full =   0;
RL_Full =   0;
w_Full  =   0; 
a   =   0;
g   =   0;
s_z =   0; 
lambda =0;
Q_Full= 0; 
infl_Full=   0;
mc_Full  =   0;
wm_Full  =   0; 
N_Full   =   0;
V_Full   =   0; 
phi_e_Full=  0;
phi_e_r_Full=0;  
om_pr_Full=  0;
L_Full   =   0;
L_r_Full =   0;
L_e_Full =   0;
N_b_Full  =  0;
phi_b_Full=  0; 
z_Full   =   0;
Profratio_Full=   0;
Rat_Full =   0;
s1_4_Full=   0;
s2_4_Full=   0;
s3_4_Full=   0;
s4_4_Full=   0;
R_4_Full=    0;
infl_4_Full= 0;
end;
resid;
steady;


check;

shocks;

var e_a=(sd_a)^2;
var e_i=(sd_i)^2;
var e_g=(sd_g)^2;
var e_a_I=(sd_I_a_I)^2;
var e_N=sd_e_N^2;
var e_z=sd_e_z^2;
var e_lambda=sd_e_lambda^2;
var e_p=sd_e_p^2;
var e_w=sd_e_w^2;
var e_sigma=sd_e_sigma^2;
var e_c=sd_e_c^2;

end;

if      modtype==1;
            if MOM==1;
                    stoch_simul(order=1, irf=40, nograph, hp_filter=1600, ar=1) GDP_Full C_p_Full I_Full l_Full s4_4_Full phi_e_r_Full N_Full Rat_Full L_Full N_b_Full Profratio_Full Profits_Full w_Full phi_b_Full L_Full L_e_Full R_4_Full Rk_4_Full infl_4_Full s3_4_Full s2_4_Full Y_Full Q_Full K_Full k_Full Y_Full mc_Full phi_e_r_Full Ae_Full g_Ae_Full g_Ab_Full g_phi_e_r_Full g_phi_b_Full g_GDP_Full;
            else;
                    stoch_simul(order=1, irf=40, nograph, nomoments) GDP_Full C_p_Full I_Full l_Full s4_4_Full phi_e_r_Full N_Full Rat_Full L_Full N_b_Full Profratio_Full Profits_Full w_Full phi_b_Full L_Full L_e_Full R_4_Full Rk_4_Full infl_4_Full s3_4_Full s2_4_Full Y_Full Q_Full K_Full k_Full Y_Full mc_Full phi_e_r_Full Ae_Full g_Ae_Full g_Ab_Full g_phi_e_r_Full g_phi_b_Full g_GDP_Full;
            end; 
elseif modtype==5;
        stoch_simul(order=1, irf=40, nograph, nomoments, periods=1000) GDP_Full C_p_Full I_Full l_Full s4_4_Full phi_e_r_Full N_Full Rat_Full L_Full N_b_Full Profratio_Full Profits_Full w_Full phi_b_Full L_Full L_e_Full R_4_Full Rk_4_Full infl_4_Full s3_4_Full s2_4_Full Y_Full Q_Full K_Full k_Full Y_Full mc_Full phi_e_r_Full Ae_Full g_Ae_Full g_Ab_Full g_phi_e_r_Full g_phi_b_Full g_GDP_Full;
elseif modtype==6;
        stoch_simul(order=1, irf=40, nograph, nomoments) GDP_Full C_p_Full I_Full l_Full s4_4_Full phi_e_r_Full N_Full Rat_Full L_Full N_b_Full Profratio_Full Profits_Full w_Full phi_b_Full L_Full L_e_Full R_4_Full Rk_4_Full infl_4_Full s3_4_Full s2_4_Full Y_Full Q_Full K_Full k_Full Y_Full mc_Full phi_e_r_Full Ae_Full g_Ae_Full g_Ab_Full g_phi_e_r_Full g_phi_b_Full g_GDP_Full;
end    

