Var Y_GK GDP_GK I_GK K_GK l_GK U_GK C_GK C_p_GK C_b_GK C_nr_GK varrho_GK R_GK R_gov_GK rk_GK Rb_GK Rk_GK w_GK a a_I g s_z lambda Q_GK infl_GK mc_GK wm_GK L_GK L_r_GK L_e_GK N_b_GK phi_b_GK z_GK Profratio_GK Rat_GK s1_4_GK s2_4_GK s3_4_GK s4_4_GK R_4_GK Rk_4_GK infl_4_GK k_GK N_GK phi_e_GK Rb_book_GK Rat_book2_GK N_b_book2_GK K_GK_book N_b_Fair_GK Rat_Fair_GK phi_b_Fair_GK K_Fair_GK L_Fair_GK L_book_GK D_GK qual g_Ab_GK g_phi_b_GK g_GDP_GK g_Ab_Fair_GK g_phi_b_Fair_GK;
Var eps_p eps_w eps_c;
varexo e_z e_a e_i e_g e_a_I e_N_b e_lambda e_p e_w e_c e_qual;

parameters alpha delta beta chi c_U psi_k psi_l varphi s_nr hh eta_i xi gamma_P kappa_pi kappa_dpi kappa_X kappa_GDP kappa_Y rho_i  rho_g rho_a rho_a_I rho_qual rho_sigma  rho_e_lambda rho_e_p mu_e_p rho_e_w mu_e_w rho_e_c epsilon mu epsilonw xiw gamma_W sigma_ss brate gamma  Theta Thetab  pin theta_ss lambda_ss  ;
parameters Y_ss GDP_ss K_ss YK_ss l_ss C_ss  C_p_ss C_b_ss C_nr_ss I_ss Gov_ss govshare R_ss varrho_ss Rk_ss rk_ss Rb_ss   s2_ss   Pm_ss k_ss w_ss X_ss   infl_ss  S_ss L_ss L_r_ss L_e_ss N_b_ss Nbe_ss Nbn_ss v_ss eta_ss x_ss z_ss phi_b_ss;

load temp1;
load temp_simtype;

//Households
beta    =   p_Full(1);
hh       =  p_Full(2);
varphi  =   p_Full(3);
s_nr    =   p_Full(4);

//Wage Setting;
epsilonw=   p_Full(5);
xiw     =   p_Full(6);
gamma_W =   p_Full(7);

//Entrepreneurs
alpha   =   p_Full(8);
delta   =   p_Full(9);
sigma_ss=   p_Full(10);
pin     =   p_Full(11);
Theta   =   p_Full(12);
gamma   =   p_Full(13);
c_U     =   p_Full(14);
psi_k   =   p_Full(15);
psi_l   =   p_Full(16);
mu      =   p_Full(17);

//bankers
theta_ss =  p_Full(18);
Thetab  =   p_Full(19);

//Capital good's producers
eta_i   =   p_Full(20);

//Retailers
xi      =   p_Full(21);
gamma_P =   p_Full(22);
epsilon =   p_Full(23);
S_ss    =   p_Full(24);

//Monetary Policy
kappa_pi=   p_Full(25);
kappa_dpi=  p_Full(26);
kappa_X =   p_Full(27);
kappa_Y =   p_Full(28);
rho_i   =   p_Full(29);
kappa_GDP=  p_Full(30);

//shock process
rho_a   =   p_Full(31);
rho_g   =   p_Full(32);
rho_a_I =   p_Full(33);
rho_e_lambda=p_Full(34);
rho_e_c =   p_Full(35);
sd_a    =   p_Full(36);
sd_i    =   p_Full(37);
sd_g    =   p_Full(38);
sd_I_a_I=   p_Full(39);
sd_e_N  =   p_Full(40);
sd_e_z  =   p_Full(41);
sd_e_lambda=p_Full(42);
sd_e_c  =   p_Full(43);

//calibrated Steady State Values
infl_ss =   p_Full(44);
govshare=   p_Full(45);
s2_ss   =   p_Full(46);
l_ss    =   p_Full(47);            
phi_b_ss=   p_Full(48);          
brate   =   p_Full(49);

//shock processes continued 
sd_e_p  =   p_Full(50);
rho_e_p =   p_Full(51);
mu_e_p  =   p_Full(52);

sd_e_w  =   p_Full(53);
rho_e_w =   p_Full(54);
mu_e_w  =   p_Full(55);

sd_e_sigma  = p_Full(56);
rho_sigma =   p_Full(57);

sd_e_qual  =  0;
rho_qual =  0.7;

//Steady State
R_ss    =   1/beta*infl_ss;

//Most variables and backed out parameters pertaining to the entrepreneurial sector
Rb_ss   =   R_ss*s2_ss;
Rk_ss   =   Rb_ss;

//most real variables
X_ss    =   epsilon/(epsilon-1);
rk_ss   =   Rk_ss/infl_ss-(1-delta);
Pm_ss   =   1/X_ss; 
Q_ss    =   1;
k_ss    =   (alpha/(X_ss*(1+psi_k*(R_ss-1))*(Rk_ss/infl_ss-1+delta)))^(1/(1-alpha));
w_ss    =   1/(X_ss*(1+psi_l*(R_ss-1)))*(1-alpha)*k_ss^alpha;
YK_ss   =   X_ss/alpha*(Rk_ss/infl_ss-1+delta)*(1+psi_k*(R_ss-1));
K_ss    =   l_ss*k_ss;
Y_ss     =  YK_ss*K_ss;
Gov_ss  =   govshare*Y_ss;
I_ss    =   delta*K_ss;

//Remaining entrepreneurial variables
L_e_ss  =   K_ss;
L_r_ss  =   psi_k*rk_ss*K_ss+psi_l*w_ss*l_ss;
L_ss    =   L_r_ss+L_e_ss;

//Banking Sector variables and backed out parameters
z_ss    =   ((Rb_ss-R_ss)*phi_b_ss+R_ss)/infl_ss;
x_ss    =   z_ss;
eta_ss  =   (1-theta_ss)/(1-beta*theta_ss*x_ss);
v_ss    =   (1-theta_ss)*1/R_ss*(Rb_ss-R_ss)/(1-beta*theta_ss*z_ss);
lambda_ss=   (eta_ss+phi_b_ss*v_ss)/phi_b_ss;
N_b_ss  =   L_e_ss/phi_b_ss;
Nbe_ss  =   theta_ss*z_ss*N_b_ss;
Nbn_ss  =   N_b_ss-Nbe_ss;

//Consumption, GDP
C_b_ss  =   Thetab*(1-theta_ss)*z_ss*N_b_ss;
C_nr_ss =   l_ss*w_ss*s_nr;
C_ss    =   Y_ss-C_nr_ss-I_ss-Gov_ss-C_b_ss;
C_p_ss  =   C_ss+C_nr_ss+C_b_ss;
GDP_ss  =   C_p_ss+I_ss+Gov_ss;
varrho_ss=  1/(C_ss*(1-hh));
chi     =   varrho_ss*w_ss/l_ss^varphi*(epsilonw-1)/epsilonw; // backed out parameter: weight of labour in utility function

model (linear);
//Households
varrho_GK*(1-beta*hh)*(1-hh)  = -(1+beta*hh^2)*C_GK+hh*C_GK(-1)+beta*hh*C_GK(+1);
varrho_GK=   varrho_GK(+1)+R_gov_GK-infl_GK(+1);
R_GK=R_gov_GK-(1+hh)/(1-hh)*eps_c;
C_nr_GK  =   l_GK+w_GK;

//wage setting
w_GK  =   1/(1+beta)*(beta*w_GK(+1)+w_GK(-1)+beta*infl_GK(+1)-(1+beta*gamma_W)*infl_GK+gamma_W*infl_GK(-1)-(1-xiw*beta)*(1-xiw)/(xiw*(1+epsilonw*varphi))*(w_GK+varrho_GK-varphi*l_GK))+eps_w;
wm_GK =   w_GK+varrho_GK-varphi*l_GK;

//retailers
infl_GK=   1/(1+beta*gamma_P)*(beta*infl_GK(+1)+gamma_P*infl_GK(-1)+(1-xi*beta)*(1-xi)/xi*mc_GK)+eps_p;
w_GK+R_GK*psi_l*R_ss/(1+psi_l*(R_ss-1))=   mc_GK+Y_GK-l_GK;
rk_GK/rk_ss+R_GK*psi_k*R_ss/(1+psi_k*(R_ss-1))=   mc_GK+Y_GK-K_GK(-1)-U_GK;
L_r_GK=   psi_l*w_ss*l_ss*(w_GK+l_GK)+psi_k*K_ss*rk_ss*(rk_GK/rk_ss+U_GK+K_GK(-1));

//Capital Goods producing Sector
K_GK    =   (1-delta)*K_GK(-1)+delta*I_GK+delta*(1+beta)*eta_i*a_I+qual;
K_GK_book=   (1-delta)*K_GK_book(-1)+delta*I_GK+delta*(1+beta)*eta_i*a_I;
I_GK    =   1/(1+beta)*(I_GK(-1)+beta*I_GK(+1)+Q_GK/eta_i)+a_I;

//Banking Sector 
L_e_GK  =   phi_b_GK+N_b_GK;
phi_b_GK=   theta_ss*beta^2*z_ss^2*phi_b_GK(+1)+phi_b_ss*Rb_ss/R_ss*(Rb_GK(+1)-R_GK)-theta_ss*beta^2*z_ss^2*s_z(+1)-phi_b_ss*lambda_ss/eta_ss*(lambda-theta_ss*beta*z_ss*lambda(+1));   
z_GK    =   (phi_b_ss*(Rb_ss*Rb_GK-R_ss*R_GK(-1))+phi_b_ss*(Rb_ss-R_ss)*phi_b_GK(-1)+R_ss*R_GK(-1))/(z_ss*infl_ss)-infl_GK-s_z;
N_b_GK  =   z_ss*theta_ss*(z_GK+N_b_GK(-1)-e_N_b);
C_b_GK  =   z_GK+N_b_GK(-1)-e_N_b;
Profratio_GK=  z_ss*z_GK;
phi_b_Fair_GK=  K_Fair_GK-N_b_Fair_GK;

N_b_ss*N_b_book2_GK= -Q_GK*K_ss+N_b_ss*N_b_GK;
N_b_Fair_GK*N_b_ss=K_ss*K_Fair_GK-(Q_GK*K_ss+K_ss*K_GK-N_b_ss*N_b_GK);
K_Fair_GK=K_GK_book+0.25*Q_GK;
D_GK*(phi_b_ss-1)= phi_b_ss*L_e_GK-N_b_GK;

//Entrepreneurial Sector
Rb_GK   =   infl_GK+infl_ss/Rk_ss*(rk_GK+Q_GK*(1-delta))-Q_GK(-1)+qual;
Rb_book_GK= infl_GK+infl_ss/Rk_ss*(rk_GK);
Rk_GK   =   Rb_GK;
rk_GK   =   rk_ss*c_U*U_GK;
L_e_GK  =   Q_GK+K_GK;
N_GK    =   0;
phi_e_GK=   0;

//Monetary Policy
R_gov_GK*R_ss  =   (1-rho_i)*(kappa_pi*infl_GK+kappa_Y*mc_GK)+rho_i*R_ss*R_gov_GK(-1)+e_i;

//Equilibrium
Y_GK    =   alpha*(U_GK+K_GK(-1))+(1-alpha)*(a+l_GK);
C_p_GK  =   C_ss/C_p_ss*C_GK+C_nr_ss/C_p_ss*C_nr_GK+C_b_ss/C_p_ss*C_b_GK;
Y_GK    =   I_ss/Y_ss*I_GK+C_p_ss/Y_ss*C_p_GK+govshare*g+rk_ss*K_ss/Y_ss*U_GK;
GDP_GK  =   I_ss/GDP_ss*I_GK+C_p_ss/GDP_ss*C_p_GK+Gov_ss/GDP_ss*g;
s1_4_GK =  0;
s2_4_GK =  4*(Rb_GK(+1)-R_gov_GK);
s3_4_GK =  4*(Rk_GK(+1)-R_gov_GK);
s4_4_GK=  0;
R_4_GK=   4*R_gov_GK;
Rk_4_GK=  4*Rk_GK;
infl_4_GK=4*infl_GK;
L_GK    =   1/L_ss*L_r_GK+L_e_ss/L_ss*L_e_GK;
L_book_GK    =   1/L_ss*L_r_GK+L_e_ss/L_ss*K_GK;
L_Fair_GK    =   1/L_ss*L_r_GK+L_e_ss/L_ss*K_Fair_GK;
Rat_GK*L_ss/N_b_ss=   N_b_GK-L_GK;
k_GK   =   K_GK-l_GK;
Rat_book2_GK*L_ss/N_b_ss=   N_b_book2_GK-L_book_GK;
Rat_Fair_GK*L_ss/N_b_ss =   N_b_Fair_GK-L_Fair_GK;

g_Ab_GK    =   L_GK-L_GK(-1); 
g_phi_b_GK =   (-Rat_GK+Rat_GK(-1))*L_ss/N_b_ss;
g_Ab_Fair_GK=  L_Fair_GK-L_Fair_GK(-1);
g_phi_b_Fair_GK =   (-Rat_Fair_GK+Rat_Fair_GK(-1))*L_ss/N_b_ss;
g_GDP_GK   =   GDP_GK-GDP_GK(-1); 

//Driving Processes
a       =   rho_a*a(-1)-e_a;
a_I     =   rho_a_I*a_I(-1)+e_a_I;
g       =   rho_g*g(-1)+e_g;
eps_p   =   rho_e_p*eps_p(-1)+e_p-mu_e_p*e_p(-1);   
eps_w   =   rho_e_w*eps_w(-1)+e_w-mu_e_w*e_w(-1);
s_z     =   e_z;
lambda  =   rho_e_lambda*lambda(-1)+e_lambda;
eps_c   =   rho_e_c*eps_c(-1)+e_c;
qual    =   rho_qual*qual(-1)-e_qual;

end;

initval;
Y_GK  =   0;
GDP_GK=   0;
I_GK  =   0; 
K_GK  =   0; 
l_GK  =   0;
U_GK  =   0; 
C_GK  =   0;
C_p_GK=   0;
C_b_GK=   0;
C_nr_GK=  0; 
varrho_GK=0;
R_GK  =   0;
R_gov_GK= 0; 
Rk_GK =   0;
rk_GK =   0; 
Rb_GK =   0;
w_GK  =   0; 
a   =   0;
g   =   0;
s_z =   0; 
Q_GK= 0; 
infl_GK=   0;
mc_GK  =   0;
wm_GK  =   0; 
L_GK   =   0;
L_r_GK =   0;
L_e_GK =   0;
N_b_GK  =  0;
phi_b_GK=  0; 
z_GK   =   0;
Profratio_GK=0;
Rat_GK =   0;
s1_4_GK=   0;
s2_4_GK=   0;
s3_4_GK=   0;
s4_4_GK=   0;
R_4_GK=    0;
infl_4_GK= 0;
N_GK   =   0;
phi_e_GK=  0;
 
Rb_book_GK=0;
Rat_book2_GK=0; 
N_b_book2_GK=0;
L_Fair_GK  =0; 
L_book_GK  =0;
phi_b_Fair_GK=0;
D_GK=      0;

end;
resid;
steady;

check;

shocks;

var e_a=(sd_a)^2;
var e_i=(sd_i)^2;
var e_g=(sd_g)^2;
var e_a_I=(sd_I_a_I)^2;
var e_z=sd_e_z^2;
var e_lambda=sd_e_lambda^2;
var e_p=sd_e_p^2;
var e_w=sd_e_w^2;
var e_c=sd_e_c^2;
var e_qual=sd_e_qual^2;

end;
//stoch_simul(order=1, irf=40, nograph, hp_filter=1600, ar=1, periods=1000)  GDP_GK C_p_GK I_GK l_GK s2_4_GK phi_e_GK N_GK Rat_GK L_GK N_b_GK Profratio_GK L_Fair_GK Rat_Fair_GK N_b_Fair_GK w_GK phi_b_GK L_GK L_e_GK R_4_GK Rk_4_GK infl_4_GK s3_4_GK s2_4_GK Y_GK Q_GK K_GK k_GK N_GK mc_GK Rb_book_GK Rat_book2_GK N_b_book2_GK phi_b_Fair_GK K_Fair_GK D_GK C_b_GK qual C_GK g_Ab_GK g_phi_b_GK g_GDP_GK;

if      modtype==4;
            if MOM==1;
                    stoch_simul(order=1, irf=40, nograph, hp_filter=1600, ar=1) GDP_GK C_p_GK I_GK l_GK s2_4_GK phi_e_GK N_GK Rat_GK L_GK N_b_GK Profratio_GK L_Fair_GK Rat_Fair_GK N_b_Fair_GK w_GK phi_b_GK L_GK L_e_GK R_4_GK Rk_4_GK infl_4_GK s3_4_GK s2_4_GK Y_GK Q_GK K_GK k_GK N_GK mc_GK Rb_book_GK Rat_book2_GK N_b_book2_GK phi_b_Fair_GK K_Fair_GK D_GK C_b_GK qual C_GK g_Ab_GK g_phi_b_GK g_GDP_GK;
            else;
                    stoch_simul(order=1, irf=40, nograph, nomoments) GDP_GK C_p_GK I_GK l_GK s2_4_GK phi_e_GK N_GK Rat_GK L_GK N_b_GK Profratio_GK L_Fair_GK Rat_Fair_GK N_b_Fair_GK w_GK phi_b_GK L_GK L_e_GK R_4_GK Rk_4_GK infl_4_GK s3_4_GK s2_4_GK Y_GK Q_GK K_GK k_GK N_GK mc_GK Rb_book_GK Rat_book2_GK N_b_book2_GK phi_b_Fair_GK K_Fair_GK D_GK C_b_GK qual C_GK g_Ab_GK g_phi_b_GK g_GDP_GK;
            end; 
elseif modtype==5;
        stoch_simul(order=1, irf=40, nograph, nomoments, periods=1000) GDP_GK C_p_GK I_GK l_GK s2_4_GK phi_e_GK N_GK Rat_GK L_GK N_b_GK Profratio_GK L_Fair_GK Rat_Fair_GK N_b_Fair_GK w_GK phi_b_GK L_GK L_e_GK R_4_GK Rk_4_GK infl_4_GK s3_4_GK s2_4_GK Y_GK Q_GK K_GK k_GK N_GK mc_GK Rb_book_GK Rat_book2_GK N_b_book2_GK phi_b_Fair_GK K_Fair_GK D_GK C_b_GK qual C_GK g_Ab_GK g_phi_b_GK g_GDP_GK;
elseif modtype==6;
        stoch_simul(order=1, irf=40, nograph, nomoments) GDP_GK C_p_GK I_GK l_GK s2_4_GK phi_e_GK N_GK Rat_GK L_GK N_b_GK Profratio_GK L_Fair_GK Rat_Fair_GK N_b_Fair_GK w_GK phi_b_GK L_GK L_e_GK R_4_GK Rk_4_GK infl_4_GK s3_4_GK s2_4_GK Y_GK Q_GK K_GK k_GK N_GK mc_GK Rb_book_GK Rat_book2_GK N_b_book2_GK phi_b_Fair_GK K_Fair_GK D_GK C_b_GK qual C_GK g_Ab_GK g_phi_b_GK g_GDP_GK;
end    



