Var Y_nofr GDP_nofr I_nofr K_nofr l_nofr U_nofr C_nofr varrho_nofr R_nofr R_gov_nofr rk_nofr w_nofr a a_I g Q_nofr infl_nofr mc_nofr wm_nofr Rk_nofr R_4_nofr Rk_4_nofr infl_4_nofr s3_4_nofr s2_4_nofr s4_4_nofr phi_e_nofr N_nofr Rat_nofr N_b_nofr phi_b_nofr L_nofr L_e_nofr L_r_nofr C_p_nofr;
Var eps_p eps_w eps_c;
varexo e_a e_i e_a_I e_qual e_Bu e_g d_i e_N e_Rb e_p e_w e_c;
parameters alpha delta beta chi psi_k psi_l varphi hh eta_i xi gamma_P xiw epsilonw gamma_W kappa_pi kappa_dpi kappa_Y kappa_X rho_i rho_g rho_e_p mu_e_p rho_e_w mu_e_w epsilon rho_a rho_a_I rho_e_c c_U;
parameters Y_ss GDP_ss K_ss YK_ss l_ss C_ss I_ss Gov_ss govshare R_ss Rk_ss rk_ss s2_ss Q_ss Pm_ss k_ss w_ss X_ss infl_ss S_ss L_r_ss;

load temp1;
load temp_simtype;

//Households
beta    =   p_Full(1);
hh       =  p_Full(2);
varphi  =   p_Full(3);
s_nr    =   p_Full(4);

//Wage Setting;
epsilonw=   p_Full(5);
xiw     =   p_Full(6);
gamma_W =   p_Full(7);

//Entrepreneurs
alpha   =   p_Full(8);
delta   =   p_Full(9);
sigma_ss=   p_Full(10);
pin     =   p_Full(11);
Theta   =   p_Full(12);
gamma   =   p_Full(13);
c_U     =   p_Full(14);
psi_k   =   p_Full(15);
psi_l   =   p_Full(16);
mu      =   p_Full(17);

//bankers
theta_ss =  p_Full(18);
Thetab  =   p_Full(19);

//Capital good's producers
eta_i   =   p_Full(20);

//Retailers
xi      =   p_Full(21);
gamma_P =   p_Full(22);
epsilon =   p_Full(23);
S_ss    =   p_Full(24);

//Monetary Policy
kappa_pi=   p_Full(25);
kappa_dpi=  p_Full(26);
kappa_X =   p_Full(27);
kappa_Y =   p_Full(28);
rho_i   =   p_Full(29);
kappa_GDP=  p_Full(30);

//shock process
rho_a   =   p_Full(31);
rho_g   =   p_Full(32);
rho_a_I =   p_Full(33);
rho_e_lambda=p_Full(34);
rho_e_c =   p_Full(35);
sd_a    =   p_Full(36);
sd_i    =   p_Full(37);
sd_g    =   p_Full(38);
sd_I_a_I=   p_Full(39);
sd_e_N  =   p_Full(40);
sd_e_z  =   p_Full(41);
sd_e_lambda=p_Full(42);
sd_e_c  =   p_Full(43);

//calibrated Steady State Values
infl_ss =   p_Full(44);
govshare=   p_Full(45);
s2_ss   =   p_Full(46);
l_ss    =   p_Full(47);            
phi_b_ss=   p_Full(48);          
brate   =   p_Full(49);

//shock processes continued 
sd_e_p  =   p_Full(50);
rho_e_p =   p_Full(51);
mu_e_p  =   p_Full(52);

sd_e_w  =   p_Full(53);
rho_e_w =   p_Full(54);
mu_e_w  =   p_Full(55);

sd_e_sigma  = p_Full(56);
rho_sigma =   p_Full(57);


//Steady State
R_ss    =   1/beta*infl_ss;
Rk_ss   =   R_ss;
rk_ss   =   Rk_ss/infl_ss-(1-delta);

X_ss    =   epsilon/(epsilon-1);
rk_ss   =   Rk_ss/infl_ss-(1-delta);
Pm_ss   =   1/X_ss; 
Q_ss    =   1;
k_ss    =   (alpha/(X_ss*(1+psi_k*(R_ss-1))*(Rk_ss/infl_ss-1+delta)))^(1/(1-alpha));
w_ss    =   1/(X_ss*(1+psi_l*(R_ss-1)))*(1-alpha)*k_ss^alpha;
YK_ss   =   X_ss/alpha*(Rk_ss/infl_ss-1+delta)*(1+psi_k*(R_ss-1));
K_ss    =   l_ss*k_ss;
Y_ss     =  YK_ss*K_ss;
Gov_ss  =   govshare*Y_ss;
I_ss    =   delta*K_ss;
C_ss    =   Y_ss-I_ss-Gov_ss;
varrho_ss=  1/(C_ss*(1-hh));
chi     =   varrho_ss*w_ss/l_ss^varphi*(epsilonw-1)/epsilonw; // backed out parameter: weight of labour in utility function
GDP_ss  =   C_ss+I_ss+Gov_ss;

L_r_ss  =   psi_k*rk_ss*K_ss+psi_l*w_ss*l_ss;

model;
//Households
varrho_nofr*(1-beta*hh)*(1-hh)  = -(1+beta*hh^2)*C_nofr+hh*C_nofr(-1)+beta*hh*C_nofr(+1);
varrho_nofr=   varrho_nofr(+1)+R_gov_nofr-infl_nofr(+1);
R_nofr=R_gov_nofr-(1+hh)/(1-hh)*eps_c;


Q_nofr  =   beta*(-(R_nofr-infl_nofr(+1))*(rk_ss+(1-delta))+rk_nofr(+1)+Q_nofr(+1)*(1-delta));
rk_nofr =   rk_ss*c_U*U_nofr;

//wage setting
w_nofr  =   1/(1+beta)*(beta*w_nofr(+1)+w_nofr(-1)+beta*infl_nofr(+1)-(1+beta*gamma_W)*infl_nofr+gamma_W*infl_nofr(-1)-(1-xiw*beta)*(1-xiw)/(xiw*(1+epsilonw*varphi))*(w_nofr+varrho_nofr-varphi*l_nofr-eps_w));
wm_nofr =   w_nofr+varrho_nofr-varphi*l_nofr;

//retailers
infl_nofr=   1/(1+beta*gamma_P)*(beta*infl_nofr(+1)+gamma_P*infl_nofr(-1)+(1-xi*beta)*(1-xi)/xi*mc_nofr)+eps_p;
w_nofr+R_nofr*psi_l*R_ss/(1+psi_l*(R_ss-1))=   mc_nofr+Y_nofr-l_nofr;
rk_nofr/rk_ss+R_nofr*psi_k*R_ss/(1+psi_k*(R_ss-1))=   mc_nofr+Y_nofr-K_nofr(-1)-U_nofr;
L_r_nofr=   psi_l*w_ss*l_ss*(w_nofr+l_nofr)+psi_k*K_ss*rk_ss*(rk_nofr/rk_ss+U_nofr+K_nofr(-1));

//Capital Goods producing Sector
K_nofr  =   (1-delta)*K_nofr(-1)+delta*I_nofr+delta*(1+beta)*eta_i*a_I;
I_nofr  =   1/(1+beta)*(I_nofr(-1)+beta*I_nofr(+1)+Q_nofr/eta_i-beta*a_I(+1))+a_I;

//Monetary Policy
R_gov_nofr*R_ss  =   (1-rho_i)*(kappa_pi*infl_nofr+kappa_Y*mc_nofr)+rho_i*R_ss*R_gov_nofr(-1)+e_i;

//Equilibrium
Y_nofr  =   alpha*(U_nofr+K_nofr(-1))+(1-alpha)*(a+l_nofr);
Y_nofr  =   I_ss/Y_ss*I_nofr+C_ss/Y_ss*C_nofr+govshare*g+rk_ss*K_ss/Y_ss*U_nofr;
GDP_nofr=   I_ss/GDP_ss*I_nofr+C_ss/GDP_ss*C_nofr+Gov_ss/GDP_ss*g;

C_p_nofr=   C_nofr;
Rk_nofr =   R_nofr;
R_4_nofr=   4*R_gov_nofr;
Rk_4_nofr=   4*Rk_nofr;
infl_4_nofr=   4*infl_nofr;
s2_4_nofr=   0;
s3_4_nofr=   0;
s4_4_nofr=   0;
phi_e_nofr=   0;
N_nofr  =   0; 
Rat_nofr=   0; 
N_b_nofr=   0;
phi_b_nofr=   0;  
L_e_nofr =   0;
L_nofr  =   1/L_r_ss*L_r_nofr;

//Driving Processes
a       =   rho_a*a(-1)-e_a;
a_I     =   rho_a_I*a_I(-1)+e_a_I;
g       =   rho_g*g(-1)+e_g;
eps_p   =   rho_e_p*eps_p(-1)+e_p-mu_e_p*e_p(-1);   
eps_w   =   rho_e_w*eps_w(-1)+e_w-mu_e_w*e_w(-1);
eps_c   =   rho_e_c*eps_c(-1)+e_c;

end;

initval;
Y_nofr=   0;
GDP_nofr=   0;
I_nofr=   0; 
K_nofr=   0; 
l_nofr=   0;
U_nofr=   0; 
C_nofr=   0;
varrho_nofr =0;
R_nofr= 0;
R_gov_nofr=0; 
rk_nofr=0; 
w_nofr= 0; 
a   =   0;
g   =   0; 
Q_nofr= 0; 
infl_nofr=0;
mc_nofr=0;
wm_nofr=0;
Rk_nofr=0;
R_4_nofr=0;
Rk_4_nofr=0;
infl_4_nofr= 0;
s2_4_nofr=0;
s3_4_nofr=0;
s4_4_nofr=0;
phi_e_nofr=0;
N_nofr   = 0; 
Rat_nofr=  0; 
L_nofr   =   0; 
N_b_nofr =   0;
phi_b_nofr=  0; 
L_nofr   =   0; 
L_e_nofr =   0; 
end;
resid;
steady;


check;

shocks;

var e_a=(sd_a)^2;
var e_i=(sd_i)^2;
var e_g=(sd_g)^2;
var e_a_I=(sd_I_a_I)^2;
var e_N=sd_e_N^2;
var e_p=sd_e_p^2;
var e_w=sd_e_w^2;
var e_c=sd_e_c^2;

end;

stoch_simul(order=1, irf=40, nograph, nomoments) GDP_nofr C_p_nofr l_nofr I_nofr s4_4_nofr phi_e_nofr N_nofr Rat_nofr L_nofr N_b_nofr w_nofr phi_b_nofr L_nofr L_e_nofr R_4_nofr Rk_4_nofr infl_4_nofr s3_4_nofr s2_4_nofr Y_nofr Q_nofr mc_nofr;
